/*******************************************************************************
 * Copyright (c) 2007, 2010 THALES GLOBAL SERVICES.
 * This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *    Obeo - initial API and implementation
 *******************************************************************************/
package org.eclipse.sirius.diagram.ui.internal.edit.parts;

/**
 * This class keeps track of the Notation view ID's which were mapping to edit
 * parts and which have been joined in a single edit part later one.
 * 
 * @author cbrun
 * 
 */
public class NotationViewIDs {
    /**
     * specific info from the former DNodeNameEditPart class : view model ID
     */
    public static final int DNODE_NAME_EDIT_PART_VISUAL_ID = 5002;

    /**
     * specific info from the former DNodeName2EditPart class : view model ID
     */
    public static final int DNODE_NAME_2_EDIT_PART_VISUAL_ID = 5001;

    /**
     * specific info from the former DNodeName3EditPart class : view model ID
     */
    public static final int DNODE_NAME_3_EDIT_PART_VISUAL_ID = 5003;

    /**
     * specific info from the former DNodeName4EditPart class : view model ID
     */
    public static final int DNODE_NAME_4_EDIT_PART_VISUAL_ID = 5010;
}
